Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkSpline Class Reference

`#include <vtkSpline.h>`

Inheritance diagram for vtkSpline:

[legend]
Collaboration diagram for vtkSpline:

[legend]
List of all members.

## Detailed Description

spline abstract class

Date:
  2002/11/12 20:09:10

Revision:
  1.26

vtkSpline is used to create interpolated data points for specified data. vtkSpline is an abstract class: its subclasses vtkCardinalSpline and vtkKochenekSpline do the interpolation. The current implementation of splines is limited to data dimensions not exceeding four.

Typically a spline is used by adding a sequence of points followed by use of an evaluation function (e.g., vtkCardinalSpline::Evaluate()). Since these splines are 1D, a point in this context is a independent/ dependent variable pair. Note that the parameter space of the spline ranges from (0,N-1), where N is the number of points in the spline.

Splines can also be set up to be closed or open. Closed splines continue from the last point to the first point with continuous function and derivative values. (You don't need to duplicate the first point to close the spline, just set ClosedOn.) If the spline is closed, the parameter space of the spline becomes (0,N).

See also:
  vtkCardinalSpline vtkKochenekSpline

Created by:
  - Lorensen, Bill

CVS contributions (if > 5%):
  - Lorensen, Bill (64%)
  - Schroeder, Will (24%)

CVS logs (CVSweb):
  - .`h` (`/Filtering/vtkSpline.h)`
  - .`cxx` (`/Filtering/vtkSpline.cxx)`

Definition at line 61 of file vtkSpline.h.

## Public Types
typedef vtkObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual vtkSpline * | MakeObject ()
virtual void | Compute ()=0
virtual float | Evaluate (float t)=0
void | AddPoint (float t, float x)
void | RemovePoint (float t)
void | RemoveAllPoints ()
unsigned long | GetMTime ()
virtual void | DeepCopy (vtkSpline *s)
virtual void | SetClampValue (int)
virtual int | GetClampValue ()
virtual void | ClampValueOn ()
virtual void | ClampValueOff ()
virtual void | SetClosed (int)
virtual int | GetClosed ()
virtual void | ClosedOn ()
virtual void | ClosedOff ()
virtual void | SetLeftConstraint (int)
virtual int | GetLeftConstraint ()
virtual void | SetRightConstraint (int)
virtual int | GetRightConstraint ()
virtual void | SetLeftValue (float)
virtual float | GetLeftValue ()
virtual void | SetRightValue (float)
virtual float | GetRightValue ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkSpline * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkSpline ()
| ~vtkSpline ()
float | ComputeLeftDerivative ()
float | ComputeRightDerivative ()
## Protected Attributes
unsigned long | ComputeTime
int | ClampValue
float * | Intervals
float * | Coefficients
int | LeftConstraint
float | LeftValue
int | RightConstraint
float | RightValue
vtkPiecewiseFunction * | PiecewiseFunction
int | Closed

## Member Typedef Documentation

typedef vtkObject vtkSpline::Superclass

| Reimplemented from vtkObject. Reimplemented in vtkCardinalSpline, and vtkKochanekSpline. Definition at line 64 of file vtkSpline.h.

## Constructor & Destructor Documentation

vtkSpline::vtkSpline | ( |  | ) | `[protected]`

vtkSpline::~vtkSpline | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkSpline::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject. Reimplemented in vtkCardinalSpline, and vtkKochanekSpline.

int vtkSpline::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkCardinalSpline, and vtkKochanekSpline.

virtual int vtkSpline::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkCardinalSpline, and vtkKochanekSpline.

vtkSpline* vtkSpline::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject. Reimplemented in vtkCardinalSpline, and vtkKochanekSpline.

void vtkSpline::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkObject. Reimplemented in vtkCardinalSpline, and vtkKochanekSpline.

virtual vtkSpline* vtkSpline::MakeObject | ( |  | ) | `[virtual]`

| For legacy compatibility. Do not use.

virtual void vtkSpline::SetClampValue | ( | int |  | ) | `[virtual]`

| Set/Get ClampValue. If On, results of the interpolation will be clamped to the min/max of the input data.

virtual int vtkSpline::GetClampValue | ( |  | ) | `[virtual]`

| Set/Get ClampValue. If On, results of the interpolation will be clamped to the min/max of the input data.

virtual void vtkSpline::ClampValueOn | ( |  | ) | `[virtual]`

| Set/Get ClampValue. If On, results of the interpolation will be clamped to the min/max of the input data.

virtual void vtkSpline::ClampValueOff | ( |  | ) | `[virtual]`

| Set/Get ClampValue. If On, results of the interpolation will be clamped to the min/max of the input data.

virtual void vtkSpline::Compute | ( |  | ) | `[pure virtual]`

| Compute the coefficients for the spline. Implemented in vtkCardinalSpline, and vtkKochanekSpline.

virtual float vtkSpline::Evaluate | ( | float | t | ) | `[pure virtual]`

| Interpolate the value of the spline at parametric location of t. Implemented in vtkCardinalSpline, and vtkKochanekSpline.

void vtkSpline::AddPoint | ( | float | t,
|  | float | x
| ) |

| Add a pair of points to be fit with the spline.

void vtkSpline::RemovePoint | ( | float | t | ) |

| Remove a point from the data to be fit with the spline.

void vtkSpline::RemoveAllPoints | ( |  | ) |

| Remove all points from the data.

virtual void vtkSpline::SetClosed | ( | int |  | ) | `[virtual]`

| Control whether the spline is open or closed. A closed spline forms a continuous loop: the first and last points are the same, and derivatives are continuous.

virtual int vtkSpline::GetClosed | ( |  | ) | `[virtual]`

| Control whether the spline is open or closed. A closed spline forms a continuous loop: the first and last points are the same, and derivatives are continuous.

virtual void vtkSpline::ClosedOn | ( |  | ) | `[virtual]`

| Control whether the spline is open or closed. A closed spline forms a continuous loop: the first and last points are the same, and derivatives are continuous.

virtual void vtkSpline::ClosedOff | ( |  | ) | `[virtual]`

| Control whether the spline is open or closed. A closed spline forms a continuous loop: the first and last points are the same, and derivatives are continuous.

virtual void vtkSpline::SetLeftConstraint | ( | int |  | ) | `[virtual]`

| Set the type of constraint of the left(right) end points. Four constraints are available: 0: the first derivative at left(right) most point is determined from the line defined from the first(last) two points. 1: the first derivative at left(right) most point is set to Left(Right)Value. 2: the second derivative at left(right) most point is set to Left(Right)Value. 3: the second derivative at left(right)most points is Left(Right)Value times second derivative at first interior point.

virtual int vtkSpline::GetLeftConstraint | ( |  | ) | `[virtual]`

| Set the type of constraint of the left(right) end points. Four constraints are available: 0: the first derivative at left(right) most point is determined from the line defined from the first(last) two points. 1: the first derivative at left(right) most point is set to Left(Right)Value. 2: the second derivative at left(right) most point is set to Left(Right)Value. 3: the second derivative at left(right)most points is Left(Right)Value times second derivative at first interior point.

virtual void vtkSpline::SetRightConstraint | ( | int |  | ) | `[virtual]`

| Set the type of constraint of the left(right) end points. Four constraints are available: 0: the first derivative at left(right) most point is determined from the line defined from the first(last) two points. 1: the first derivative at left(right) most point is set to Left(Right)Value. 2: the second derivative at left(right) most point is set to Left(Right)Value. 3: the second derivative at left(right)most points is Left(Right)Value times second derivative at first interior point.

virtual int vtkSpline::GetRightConstraint | ( |  | ) | `[virtual]`

| Set the type of constraint of the left(right) end points. Four constraints are available: 0: the first derivative at left(right) most point is determined from the line defined from the first(last) two points. 1: the first derivative at left(right) most point is set to Left(Right)Value. 2: the second derivative at left(right) most point is set to Left(Right)Value. 3: the second derivative at left(right)most points is Left(Right)Value times second derivative at first interior point.

virtual void vtkSpline::SetLeftValue | ( | float |  | ) | `[virtual]`

| The values of the derivative on the left and right sides. The value is used only if the left(right) constraint is type 1-3.

virtual float vtkSpline::GetLeftValue | ( |  | ) | `[virtual]`

| The values of the derivative on the left and right sides. The value is used only if the left(right) constraint is type 1-3.

virtual void vtkSpline::SetRightValue | ( | float |  | ) | `[virtual]`

| The values of the derivative on the left and right sides. The value is used only if the left(right) constraint is type 1-3.

virtual float vtkSpline::GetRightValue | ( |  | ) | `[virtual]`

| The values of the derivative on the left and right sides. The value is used only if the left(right) constraint is type 1-3.

unsigned long vtkSpline::GetMTime | ( |  | ) | `[virtual]`

| Return the MTime also considering the Piecewise function. Reimplemented from vtkObject.

virtual void vtkSpline::DeepCopy | ( | vtkSpline * | s | ) | `[virtual]`

| Deep copy of spline data. Reimplemented in vtkCardinalSpline, and vtkKochanekSpline.

float vtkSpline::ComputeLeftDerivative | ( |  | ) | `[protected]`

float vtkSpline::ComputeRightDerivative | ( |  | ) | `[protected]`

## Member Data Documentation

unsigned long vtkSpline::ComputeTime`[protected]`

| Definition at line 138 of file vtkSpline.h.

int vtkSpline::ClampValue`[protected]`

| Definition at line 139 of file vtkSpline.h.

float* vtkSpline::Intervals`[protected]`

| Definition at line 140 of file vtkSpline.h.

float* vtkSpline::Coefficients`[protected]`

| Definition at line 141 of file vtkSpline.h.

int vtkSpline::LeftConstraint`[protected]`

| Definition at line 142 of file vtkSpline.h.

float vtkSpline::LeftValue`[protected]`

| Definition at line 143 of file vtkSpline.h.

int vtkSpline::RightConstraint`[protected]`

| Definition at line 144 of file vtkSpline.h.

float vtkSpline::RightValue`[protected]`

| Definition at line 145 of file vtkSpline.h.

vtkPiecewiseFunction* vtkSpline::PiecewiseFunction`[protected]`

| Definition at line 146 of file vtkSpline.h.

int vtkSpline::Closed`[protected]`

| Definition at line 147 of file vtkSpline.h.

The documentation for this class was generated from the following file:

- Filtering/vtkSpline.h